.386
.model flat,stdcall
option casemap:none

include	\masm32\include\windows.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\gdi32.inc

includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

EXTERN pMenuTemplate:BYTE

.data
Resource        db 'MYDIALOG',0
msg             db 'Dialog box with menu template',0
title1          db 'About',0

.data?
hModule         dd ?
hBitmap         dd ?
hMenuTemplate   dd ?

IDM_ABOUT       equ 11
IDM_EXIT        equ 12
IDC_ABOUT       equ 110
IDC_EXIT        equ 120
IDC_EDIT        equ 3000
ID_BITMAP       equ 1000

.code

start:

    invoke  GetModuleHandle,0
    mov     hModule,eax
    invoke  DialogBoxParam,eax,ADDR Resource,NULL,ADDR DlgProc,0
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

LOCAL ps:PAINTSTRUCT
LOCAL hDC:HDC
LOCAL hMemDC:HDC
LOCAL rect:RECT
	
    .IF uMsg==WM_INITDIALOG
        
        invoke  LoadBitmap,hModule,ID_BITMAP
        mov     hBitmap,eax
        invoke  LoadMenuIndirect,ADDR pMenuTemplate
        mov     hMenuTemplate,eax
        invoke  SetMenu,hWnd,eax

    .ELSEIF uMsg==WM_PAINT
   
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hDC,eax
        invoke  CreateCompatibleDC,hDC
        mov     hMemDC,eax
        invoke  SelectObject,hMemDC,hBitmap
        invoke  GetClientRect,hWnd,ADDR rect
        invoke  BitBlt,hDC,0,0,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
        invoke  DeleteDC,hMemDC
        invoke  EndPaint,hWnd,ADDR ps

    .ELSEIF uMsg==WM_CLOSE

        invoke SendMessage,hWnd,WM_COMMAND,IDM_EXIT,0

    .ELSEIF uMsg==WM_COMMAND
		
        mov eax,wParam
        .IF lParam==0
            .IF ax==IDM_ABOUT
                invoke  MessageBox,NULL,ADDR msg,ADDR title1,MB_OK
                
            .ELSEIF ax==IDM_EXIT
                invoke  DeleteObject,hBitmap
                invoke  EndDialog,hWnd,NULL
            .ENDIF
        .ELSE
            mov edx,wParam
            shr edx,16
            .IF dx==BN_CLICKED
                               
                .IF ax==IDC_ABOUT
                    invoke  SendMessage,hWnd,WM_COMMAND,IDM_ABOUT,0
                        	
                .ELSEIF ax==IDC_EXIT
                
                invoke  DeleteObject,hBitmap
                invoke  EndDialog,hWnd,NULL
                .ENDIF
            .ENDIF
        .ENDIF

	.ELSE

    mov eax,FALSE
    ret

    .ENDIF

    mov eax,TRUE
    ret

DlgProc ENDP

END start